Subject: Re: IPV6_RTHDR with a type-0 routing header

From: "Steinar H. Gunderson" <[email-masked]>
Date: Thu, 20 Aug 2009 15:00:09 +0200

On Thu, Aug 20, 2009 at 02:53:44PM +0200, Jens Rosenboom wrote:
>> It looks like I can use destination options instead, but those don't seem to
>> be too easy to use either. The kernel seems to demand that I put eight bytes
>> of padding at the end?
>> 
>>   #define ipv6_optlen(p)  (((p)->hdrlen+1) << 3)
>> 
>> Why the +1? 
> Because that matches the definition of the hdrlen field in RFC2460.

Hm, in that case I guess it's glibc that has one too much indeed (I never
write this field).

>> FWIW, the program I try to run is at http://home.samfundet.no/~sesse/v6fun.c .
>> If I replace "len" in the setsockopt call by "len + 8", the program runs and
>> the packets get the right option attached -- but also eight padding bytes.
> ERROR 404: Not Found.

Sorry, http://home.samfundet.no/~sesse/v6opt.c

/* Steinar */
-- 
Homepage: http://www.sesse.net/